package com.zt.plat.module.qms.resource.record.service.recordapplydetail;

import java.util.*;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zt.plat.module.qms.resource.record.controller.admin.recordapplydetail.vo.RecordApplyDetailPageReqVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordapplydetail.vo.RecordApplyDetailRespVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordapplydetail.vo.RecordApplyDetailSaveReqVO;
import com.zt.plat.module.qms.resource.record.controller.admin.recordapplydetail.vo.RecordApplyDetailJoinVO;
import com.zt.plat.module.qms.resource.record.dal.dataobject.recordapply.RecordApplyDO;
import jakarta.validation.*;
import com.zt.plat.module.qms.resource.record.dal.dataobject.recordapplydetail.RecordApplyDetailDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 文件记录通用申请明细 Service 接口
 *
 * @author 后台管理
 */
public interface RecordApplyDetailService {

    /**
     * 创建文件记录通用申请明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    RecordApplyDetailRespVO createRecordApplyDetail(@Valid RecordApplyDetailSaveReqVO createReqVO);

    /**
     * 更新文件记录通用申请明细
     *
     * @param updateReqVO 更新信息
     */
    void updateRecordApplyDetail(@Valid RecordApplyDetailSaveReqVO updateReqVO);

    /**
     * 删除文件记录通用申请明细
     *
     * @param id 编号
     */
    void deleteRecordApplyDetail(Long id);

    /**
    * 批量删除文件记录通用申请明细
    *
    * @param ids 编号
    */
    void deleteRecordApplyDetailListByIds(List<Long> ids);

    /**
     * 获得文件记录通用申请明细
     *
     * @param id 编号
     * @return 文件记录通用申请明细
     */
    RecordApplyDetailDO getRecordApplyDetail(Long id);

    /**
     * 获得文件记录通用申请明细分页
     *
     * @param pageReqVO 分页查询
     * @return 文件记录通用申请明细分页
     */
    PageResult<RecordApplyDetailDO> getRecordApplyDetailPage(RecordApplyDetailPageReqVO pageReqVO);

    /**
     * 获得文件记录通用申请明细列表
     *
     * @param pageReqVO 查询条件
     * @return 文件记录通用申请明细列表
     */
    List<RecordApplyDetailDO> selectList(RecordApplyDetailPageReqVO pageReqVO);

    boolean createRecordApplyDetailBatch(List<RecordApplyDetailDO> detailSaveReqVOList);

    // 查询明细不分页
    List<RecordApplyDetailDO> selectAllList(Long applyId) ;


    int deleteRecordApplyDetailByApplyId(Long applyId);

    PageResult<RecordApplyDetailJoinVO> selectDetailAndApplyList(RecordApplyDetailPageReqVO reqVO);

    List<RecordApplyDetailDO> selectNotInDetailIdList(Long applyId, String type, List<Long> targetIds);

    Integer deleteNotInDetailIdList(Long applyId, List<Long> detailIds, List<Long> recordIds);

    boolean updateRecordApplyDetailBatch(List<RecordApplyDetailSaveReqVO> detailUpdateReqVOList);
}